#ifndef _FOO_H_
#define _FOO_H_

#include <iostream>

using namespace std;

class Foo
{
  public:
    Foo() : m_data(0)
    {
      newId();
      cout << m_id << ": Foo " << "Constructor (Default)" << endl;
    }

    ~Foo()
    {
      cout << m_id << ": Foo " << "Destructor" << endl;
    }

    Foo(int i) : m_data(i)
    {
      newId();
      cout << m_id << ": Foo " << "Constructor (i=" << i << ")" << endl;
    }

    Foo(const Foo &f)
    {
      newId();

      cout << m_id << ": Foo " << "Copy Constructor" << endl;
      m_data = f.data();
    }

    void operator=(const Foo &f)
    {
      cout << m_id << ": Foo " << "Assignment" << endl;
      m_data = f.data();
    }

    int data() const
    {
      return m_data;
    }

  private:
    int  m_data;

    int  m_id;

    void newId()
    {
      m_id = s_lastId;
      ++s_lastId;
    }

    static int  s_lastId;
};

int  Foo::s_lastId   = 1;

#endif
